#!/usr/bin/perl 
# Purpose:  cgi program to create aggregated perf charts over entire server
# Author: Bruce Spencer
# Date:  June 9, 2006
$version-1.0.0;
use Time::Local;

# List of variables
# %srv{server} = rrd_dir,var1,var1,...
# @sserver = list of micropartitions
# @dserver = list of LPARs


&decode_passed_data;

# Debug
# &debug;   # Show passed parameters
# Debug set $i=1 ..Ignore passed parameters and use the following
$i=0; 
if ( $i eq 1 ) {
	# $form_data{sn}="020205AEB";
	$form_data{sn}="02105F2CD";
	$form_data{startyear}="2006";
	$form_data{startmonth}="02";
	$form_data{startday}="10";
	$form_data{endyear}="2006";
	$form_data{endmonth}="02";
	$form_data{endday}="16";
} # End if
# End Debug

####################################
### Your customizations go here ####
####################################

# Absolute directory for nmon html files
$DIRECTORY="/home/baspence/public_html/nmon"; 

# Relative web subdir for HTML: http://abc.com/$WEB_DIR/index.html
$WEB_DIR='/~baspence/nmon';

####################################
### End your customizations     ####
####################################

# Get directory, server and virtual device names
&initialize;


chdir($OUTDIR);
`rm *.gif index.html rrd_graph`;

# Create rrdtool command file to create graphs
unless (open(RRDGRAPH,">$OUTDIR/rrd_graph")) { die ("Unable to open $OUTDIR/rrd_graph\n");}

# Aggregate micropartition CPU performance
if ( @sserver > 0 ) {

    print RRDGRAPH (qq|graph cpu_micro_pool_stacked.gif -r -l 0 -v "CPU Pool Used (CPUs)" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Combined Micropartition CPU Utilization (Stacked)" |);

    $type="AREA";
    for( $i=0;$i<@sserver;$i++ ) { 

      @cols=split(/,/,$srv{$sserver[$i]} );
      print RRDGRAPH (qq|DEF:P${i}=$cols[0]/lpar.rrd:PhysicalCPU:AVERAGE $type:P${i}$color[$i%20]:"$sserver[$i]" |);
      $type="STACK";

    } # end foreach
    print RRDGRAPH ("\n");
} # end if

# Dedicated LPAR CPU utilization
if ( @dserver > 0 ) {

       print RRDGRAPH (qq|graph cpu_dedicated_stacked.gif -r -l 0 -v "CPU Used (CPUs)" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Combined Dedicated (LPAR) CPU Utilization (Stacked)" |);

    $type="AREA";
    for( $i=0;$i<@dserver;$i++ ) { 

      @cols=split(/,/,$srv{$dserver[$i]} );
      print RRDGRAPH (qq|DEF:P${i}=$cols[0]/lpar.rrd:PhysicalCPU:AVERAGE $type:P${i}$color[$i%20]:"$dserver[$i]" |);
      $type="STACK";

    } # end for
    print RRDGRAPH ("\n");
} # end if

### Aggregated Memory:  Both Dedicated and Micropartitioned
chdir($SYSTEM_DIR);

print RRDGRAPH (qq|graph memory_pool_stacked.gif -r -l 0 -v "Total Memory (MB)" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Combined LPAR and Micropartition Memory Use (Stacked)" |);

$FScache="CDEF:FScache=";
$Process="CDEF:Process=";
$System="CDEF:System=";
$add="";
$comma="";

# Memory(type) = Total x %Type
$i=0;
foreach $server (keys ( %srv )){

  @cols=split(/,/,$srv{$server});

  print RRDGRAPH (qq|DEF:RealMB$i=$cols[0]/mem.rrd:Real_total_MB:AVERAGE  |);
  print RRDGRAPH (qq|DEF:Proc$i=$cols[0]/memnew.rrd:ProcessPct:AVERAGE  |);
  print RRDGRAPH (qq|DEF:FScache$i=$cols[0]/memnew.rrd:FScachePct:AVERAGE  |);
  print RRDGRAPH (qq|DEF:System$i=$cols[0]/memnew.rrd:SystemPct:AVERAGE |);
 
  print RRDGRAPH (qq|CDEF:F$i=RealMB$i,FScache$i,*,0.01,* |);
  print RRDGRAPH (qq|CDEF:P$i=RealMB$i,Proc$i,*,0.01,* |);
  print RRDGRAPH (qq|CDEF:S$i=RealMB$i,System$i,*,0.01,* |);

  # If no data, set data point to 0, otherwise entire graph is empty
  $FScache.="${comma}F$i,UN,0,F$i,IF$add";
  $Process.="${comma}P$i,UN,0,P$i,IF$add";
  $System.= "${comma}S$i,UN,0,S$i,IF$add";

  $add=',+';
  $comma=',';
  $i++;
} # end for

  print RRDGRAPH (qq|$FScache $Process $System |);
  print RRDGRAPH (qq|AREA:Process#FF0000:"Process" |);
  print RRDGRAPH (qq|STACK:FScache#00FF00:"FScache" |);
  print RRDGRAPH (qq|STACK:System#0000FF:"System" \n|);



  
### Aggregated Virtual IO
chdir($SYSTEM_DIR);

$line=qq|graph io_pool_stacked.gif -r -l 0 -v "KB per Second" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Pooled VSCSI0 KB per Second by Partition (Stacked)" |;

$k=0;
$type="AREA";
foreach $server (keys ( %srv )){
  
  @var=split(/,/,$srv{$server});
  $db="$var[0]/ioadapt.rrd";

  # looking for vscsi, scsi, or fcs adapters
  for($j=1;$j<@var;$j++) {

    if ( $var[$j] =~ /[fs]cs.*KBs/ ) { # Vars = *read*, *write*, *xfer*

      $line.=qq|DEF:P${k}=$db:$var[$j]:AVERAGE $type:P${k}$color[$k%20]:"${server}_$var[$j]" |;
      $k++;
      $type="STACK";

    } # end if

  } # end for $j

} # end foreach $server

print RRDGRAPH ("$line\n");


### Aggregated Virtual IO tps chart

$line=qq|graph iotps_pool_stacked.gif -r -l 0 -v "Transactions per Second" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Pooled VSCSI0 Transactions per Second by Partition (Stacked)" |;

$k=0;
$type="AREA";
foreach $server (keys ( %srv )){

  @var=split(/,/,$srv{$server});
  $db="$var[0]/ioadapt.rrd";

  for ($j=1;$j<@var;$j++) {

    if ( $var[$j] =~ /scsi.*xfer/ ) {
        $line.= qq| DEF:P${k}=$db:$var[$j]:AVERAGE $type:P${k}$color[$k%20]:"${server}_$var[$j]" |;
	$k++;
        $type="STACK";
    } # end if

  } # end for($j=

} # end foreach $server
print RRDGRAPH ("$line\n");


### Aggregated Network Chart (KB/s)
$line=qq|graph net_pool_stacked.gif -r -l 0 -v "KB per Second" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Pooled en0 Network KB per Second by Partition (Stacked)" |;

$type="AREA";
$k=0;
foreach $server (keys ( %srv)){

  @var=split(/,/,$srv{$server});
  $db="$var[0]/net.rrd";

  for ($j=1;$j<@var;$j++) {

    if ( $var[$j] =~ /^en.*KBs$/ ) {
        $line.= qq| DEF:P${k}=$db:$var[$j]:AVERAGE $type:P${k}$color[$k%20]:"${server}_$var[$j]" |;
	$k++;
        $type="STACK";
    } # end if

  } # end for($j=

} # end for
print RRDGRAPH ("$line\n");

# Aggregated network (packets per second)
$line=qq|graph net_tps_stacked.gif -r -l 0 -v "Packets per Second" --start $UTC_START --end $UTC_END --width 800 --height 300 --title "Server $form_data{sn} Pooled en0 Network Packets per Second by Partition (Stacked)" |;

$type="AREA";
$k=0;
foreach $server (keys ( %srv )){

  @var=split(/,/,$srv{$server});
  $db="$var[0]/netpacket.rrd";

  for ($j=1;$j<@var;$j++) {

    if ( $var[$j] =~ /^en.*ss$/ ) {
        $line.= qq| DEF:P${k}=$db:$var[$j]:AVERAGE $type:P${k}$color[$k%20]:"${server}_$var[$j]" |;
	$k++;
        $type="STACK";
    } # end if

  } # end for($j=


} # end for
print RRDGRAPH ("$line\n");


close(RRDGRAPH);

## Create the charts ##
# `rrdtool - \< rrd_graph`;
chdir($OUTDIR);
$junk=`rrdtool - \< rrd_graph`;

## Create Graphs 
# Categorize charts by name
@gif=`ls *gif`;
chomp(@gif);
@var=("CPU","Memory","IO","Net");
unless (open(HTML,">index.html")) { die ("Unable to open $OUTDIR/index.html\n");}

print HTML<<END;
<HTML>
<HEAD>
    <TITLE>Micropartitioned System Overall Utilization </TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFF">
<font color="#0000FF">
<center>
<table>
<tr>
<td bgcolor=blue align=center>
<H1><font color=white><B>System $form_data{sn}: Aggregate Micropartition Utilization</font></B></H1>
</td>
</tr><tr>
<td align=center>
<table><tr>
<td>System Serial Number:  
<td>$form_data{sn}
</tr><tr>
<td>Micropartitions:
<td>@sserver
</tr><tr>
<td>Dedicated LPARs:
<td>@dserver
</tr><tr>
<td>Start Date:
<td>$form_data{startmonth}/$form_data{startday}/$form_data{startyear}
</tr><tr>
<td>End Date:
<td>$form_data{endmonth}/$form_data{endday}/$form_data{endyear}
</tr>
<table border=1 cellspacing=0>
<tr><td valign="top">
END

# Links in left column
for($i=0;$i<@var;$i++) { print  HTML (qq|<a href="\#$var[$i]">$var[$i]</a><br>\n|);  }

print HTML (qq|</td><td>\n|);

# Actual charts by category
for($i=0;$i<@var;$i++) { 
  print HTML (qq|<h2><a name="$var[$i]">Aggregate</a> $var[$i] Utilization</h2>\n|);
  $k=lc($var[$i]);
  for ($j=0;$j<@gif;$j++){
    if ( $gif[$j] =~ /^$k/ ) {  
       print HTML (qq|<img src="$WEB_DIR/$form_data{sn}/Shared/sharedpool/$gif[$j]">\n|);
    } # end if
  } # end for $j
} # end for $i
print HTML (" </td> </tr> </table> </body> </html>\n");
close(HTML);

# redirect browser to index file
print("Location: $WEB_DIR/$form_data{sn}/Shared/sharedpool/index.html\n\n");
exit(0);

# Initialize 
sub initialize {

  my @files;
  my @cols;
  my $i;
  my $j;
  my @virt;
  my $n_vethernet;
  my $n_vadapter;

  # Mostly random colors for charts
  @color=("#0000FF","#00FF00","#FF0000","#000000","#FFFF00","#FF00FF","#00FFFF","#800000","#008000","#000080","#808000","#800080","#008080","#FF8000","#FF0080","#80FF00","#00FF80","#8000FF","#0080FF","#80FFFF","#FF80FF","#FFFF80","#505000","#500050","#005050");

  # Directories
  $SYSTEM_DIR="$DIRECTORY/$form_data{sn}";
  $SHARED_DIR="$SYSTEM_DIR/Shared";
  $DEDICATED_DIR="$SYSTEM_DIR/Dedicated";
  $OUTDIR="$SHARED_DIR/sharedpool";

  # Calc Start/End dates in UTC time (time since 1970)
  $UTC_START=timelocal(0,0,0,$form_data{startday},$form_data{startmonth} - 1,$form_data{startyear});
  $UTC_END=timelocal(0,0,0,$form_data{endday},$form_data{endmonth} - 1,$form_data{endyear});

  # Shared/microparition Server List
  if ( -d $SHARED_DIR ){
     @files=`ls $SHARED_DIR`;
     chomp(@files);
     $j=0;
     @sserver=();
     for ($i=0;$i<@files;$i++) {
	if ( length($files[$i]) gt 0 && $files[$i] !~ /sharedpool/ ) {

	   $srv{$files[$i]} = "$SHARED_DIR/$files[$i]/rrddata";# Full path 
	   $sserver[$j++]=$files[$i];

	} # end if
     } # end for
  } # end if 

  # Dedicated Servers
  if ( -d $DEDICATED_DIR ){
     @files=`ls $DEDICATED_DIR`;
     chomp(@files);
     $j=0;
     @dserver=();
     for ($i=0;$i<@files;$i++) {
	if ( length($files[$i]) gt 0 && $files[$i] !~ /sharedpool/ ) {

	   $srv{$files[$i]} = "$DEDICATED_DIR/$files[$i]/rrddata";#Full path 
	   $dserver[$j++]=$files[$i];

	} # end if
     } # end for
  } # end if 

     
  $n_vadapter=0; # virtual scsi adapter counter specified in virtual.cfg
  $n_vethernet=0;
  if (-f "$OUTDIR/virtual.cfg") { 
    open(FILE,"$OUTDIR/virtual.cfg");
    @virt=<FILE>;
    chomp(@virt);
    close(FILE);
    for ($i=0;$i<@virt;$i++) {
      if ( $virt[$i] =~ /^#/ ) {next;} 
      @cols=split(/,/,$virt[$i]);
      for($j=1;$j<@cols;$j++){
	if ($cols[$j] =~ /^en/) { 
	  $n_vethernet++; 
          $srv{$cols[0]}.=",${cols[$j]}readKBs,${cols[$j]}writeKBs,${cols[$j]}readss,${cols[$j]}writess";
	} else { 
	  $n_vadapter++; 
          $srv{$cols[0]}.=",$cols[$j]_readKBs,$cols[$j]_writeKBs,$cols[$j]_xfertps";
	} # end if
      } # end for  $j
    } # end for $i
  } # end if
  
  if ( $n_vadapter eq 0 ) {  # no vscsi adapters specified, so retrieve

    foreach $server (keys (%srv)) {

      $db="$srv{$server}/ioadapt.rrd";
      @var=&get_rrd_vars($db);

      foreach $x ( @var ) {
	if ( $x =~ /vscsi/ ) { $srv{$server}.=",$x"; }
      } # end foreach $x

    } # end foreach $server
  } # end if

  if ( $n_vethernet eq 0 ) {  # no v_enet adapters specified, so assume en0
    foreach $server ( keys ( %srv) ) {
	if ( $srv{$server} =~ /Shared/ ) { 
	  $srv{$server} .= ",en0readKBs,en0writeKBs,en0readss,en0writess"; 
	}
    } # end foreach	
  } # end if

} # end initialize

# Decode data passed to CGI program
sub decode_passed_data {

my $key;
my $value;
my @key_value_pairs;
my $key_value;

$request_method = $ENV{'REQUEST_METHOD'};

if ($request_method eq "GET") {
        $query_string = $ENV{'QUERY_STRING'};
  } elsif ($request_method eq "POST") {
        read (STDIN, $query_string, $ENV{'CONTENT_LENGTH'});
  } else  {
        # &return_error(500, "Server Error", "Invalid request method");
        return(1);
} # end if

@key_value_pairs = split(/&/, $query_string);

foreach $key_value (@key_value_pairs) {

  ($key, $value) = split (/=/, $key_value);
  $value =~ tr/+/ /;
  $value =~ s/%([\dA-Fa-f][\dA-Fa-f])/pack("C", hex ($1))/eg;

  # Cleanup....remove html tags if any
  $value =~ s/</&lt\;/g;
  $value =~ s/>/&gl\;/g;
  $value =~ s/\&/&amp\;/g;

  # remove dos new lines
  $value =~ s/\n//g;
  #$value =~ s//<br>/g;

  $form_data{$key} = $value;

  } # end foreach
return(0);
} # end decode_passed_data

# Debug
sub debug{
print <<DEBUG;
Content-type: text/html


<HTML>
<HEAD>
    <TITLE>Micropartitioned System Overall Utilization </TITLE>
</HEAD>
<BODY BGCOLOR="#FFFFF">
<font color="#0000FF">
<center>
<H1><u><B>FormData</B></u></H1>
</center>

<ul>
<li>sn - $form_data{sn}
<li>startyear - $form_data{startyear}
<li>startmonth - $form_data{startmonth}
<li>startday - $form_data{startday}
<li>endyear - $form_data{endyear}
<li>endmonth - $form_data{endmonth}
<li>endday - $form_data{endday}
</ul>
</body>
</html>
DEBUG
 
exit(0);
} # end debug

###########################
## Get RRDtool variables ##
###########################
sub  get_rrd_vars {

  my $DB;
  my @vars;
  my $i;

  $DB=(@_)[0];

  @vars=`rrdtool info $DB | grep "^ds" |cut -d. -f1 |sort -u`;
  chop(@vars);
  
  # Cleanup @vars.  Current ds[var]....Want var
  for($i=0;$i<@vars;$i++){
	$vars[$i]=~s/ds\[//;
	$vars[$i]=~s/\]//;
  } # end for

  return(@vars);

} # end get_rrd_vars
